#include <iostream>
#include<vector>
#include<algorithm>
using namespace std;
const int maxN = 2003;
vector<int> v;
vector<int> mint(20003,2003);
int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(NULL);
	cout.tie(NULL);
	long long s,n; cin >> s >> n;
	for(int i=0;i<n;i++){
		long long p; cin>>p; v.push_back(p);
	}
	sort(v.begin(),v.end());

	for(int sm=1;sm<=s;sm++){
		for(int j=0;j<n;j++){
			if(v[j]>=sm){
				if(v[j]==sm) mint[sm]=1;
				break;
			}
			mint[sm]=min(mint[sm],1+mint[sm-v[j]]);
		}
	}
	cout<<mint[s]<<'\n';
		return 0;
	}